/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import jp.mosp.common.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.system.dao.MCodeDao;
import jp.mosp.system.dto.MCodeDto;
import jp.mosp.system.vo.CodeMasterCardVo;

public class CodeMasterCardAction extends MosPAction {

	// コマンド
	private static final String CMD_CODE_CARD_SHOW   = "S2305";	// 表示(追加)
	private static final String CMD_CODE_CARD_SELECT = "S2306";	// 表示(選択)
	private static final String CMD_CODE_CARD_INSERT = "S2307";	// 登録
	private static final String CMD_CODE_CARD_UPDATE = "S2308";	// 更新
	private static final String CMD_CODE_CARD_DELETE = "S2309";	// 削除

	/**
	 * コンストラクタ
	 */
	public CodeMasterCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得及び設定
		CodeMasterCardVo vo = new CodeMasterCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DAOの準備
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// コード区分プルダウンリスト作成
		vo.aryPltTId = getMosPCodeArray();
		// DTOの取得
		MCodeDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof MCodeDto ? (MCodeDto)obj : null;
		// コマンド毎の処理
		if (cmd.equals(CMD_CODE_CARD_SHOW)) {
			// 表示(新規)
			vo.setPltTId("");
			vo.setTxtTCode("");
			vo.setTxtTName("");
			vo.setTxtTChange("");
			vo.setMode(CodeMasterCardVo.MODE_INSERT);
		} else if (cmd.equals(CMD_CODE_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			// データの取得
			dto = dao.findForKey(key1, key2);
			chkExist(dto);
			// VOに情報をセット
			vo.setFields(dto);
			setMode(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_CODE_CARD_INSERT)) {
			// 新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_CODE_CARD_UPDATE)) {		
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_CODE_CARD_DELETE)) {
			// 削除
			dto = delete(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private MCodeDto insert(CodeMasterCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate(true);
		// DAOの準備
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 存在チェック
		chkDuplicate(dao.findForKey(vo.getPltTId(), vo.getTxtTCode()), vo);
		// DTOの準備
		MCodeDto dto = new MCodeDto();
		vo.setDtoFields(dto);
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		dto = dao.findForKey(dto.getTId(), dto.getTCode());
		chkInsert(dto);
		// コミット
		commit();
		// モード設定
		setMode(vo);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private MCodeDto update(CodeMasterCardVo vo, MCodeDto dto) throws Exception {
		// コード区分取得
		vo.setPltTId(dto.getTId());
		vo.setTxtTCode(dto.getTCode());
		// パラメータの妥当性確認
		vo.validate(false);
		// DAOの準備
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dao.findForKey(dto.getTId(), dto.getTCode()), dao.findForUpdate(dto.getTId(), dto.getTCode()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		dao.update(dto);
		// DTOの再取得
		MCodeDto retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		setMode(vo);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

	/**
	 * データ削除
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private MCodeDto delete(CodeMasterCardVo vo, MCodeDto dto) throws Exception {
		// DAOの準備
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dao.findForKey(dto.getTId(), dto.getTCode()), dao.findForUpdate(dto.getTId(), dto.getTCode()), vo);
		// データの削除
		dao.delete(dto);
		// DTOの再取得
		MCodeDto retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		// コミット
		commit();
		// モード設定
		vo.setMode(CodeMasterCardVo.MODE_INSERT);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_DELETE, ""));
		return retDto;
	}

	/**
	 * モード設定
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void setMode(CodeMasterCardVo vo) throws Exception {
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(CodeMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(CodeMasterCardVo.MODE_UPDATE);
		}
	}

}
